//
// Simple volumetric raycasting fragment shader - integrating along a path
//

uniform sampler3D modelMap;
uniform vec3	light;
uniform vec3	eye;
uniform float	alpha;

varying	vec3	texCoord;
varying	vec3	l;
varying	vec3	v;

void main ()
{
	const	float	eps = 0.005;

	vec3	l2    = normalize ( l );
	vec3	v2    = normalize ( v );
	float	delta = 1.0 / 300.0;
	vec3	tex   = gl_TexCoord [0].xyz;
	vec3	t     = tex - 0.5*delta*v2;
	vec4	color = vec4 ( 0.0 );
	float	i;
	
	for ( i = 0; i < 10000; i++ )
	{
		vec4	clr = texture3D ( modelMap, tex );
		
									// alpha correct f(a)=1-pow(1-a,C/delta)
		color.rgb += (1.0 - color.a) * clr.rgb;
		color.a   += (1.0 - color.a) * clr.a;
		tex       -= delta * v2;
		
		if ( any ( lessThan ( tex, vec3 ( 0.0 ) ) ) || any ( greaterThan ( tex, vec3 ( 1.0 ) ) ) )
			i = 66000;
	}
}
