//
// Simple volumetric raycasting vertex shader - building isosurface
//

uniform vec3	light;
uniform vec3	eye;
varying	vec3	texCoord;
varying	vec3	l;
varying	vec3	v;

void main () 
{
	vec3	p = vec3 ( gl_ModelViewMatrix * gl_Vertex );	// transformed point to world space
	
	l = normalize ( light - p );						// vector to light source
	v = normalize ( eye   - p );						// vector to the eye
	l = l * gl_NormalMatrix;
	v = v * gl_NormalMatrix;
	
	gl_Position     = gl_ModelViewProjectionMatrix * gl_Vertex;
	gl_TexCoord [0] = gl_Vertex +  vec4 ( 0.5, 0.5, 0.5, 0.0 );
}
